// Package kafka...
//
// Description : kafka...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 2021-09-22 9:07 下午
package kafka

import "github.com/Shopify/sarama"

// IConsumeDataHandler ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 9:07 下午 2021/9/22
type IConsumeDataHandler interface {
	// Execute 处理数据
	Execute(data *sarama.ConsumerMessage) error
	// Success 成功回调
	Success(data *sarama.ConsumerMessage)
	// Fail 处理失败回调
	Fail(data *sarama.ConsumerMessage, err error)
	// Exception 消费出现异常回调
	Exception(err error)
}
