// Package system...
//
// Description : system...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 2021-10-12 5:48 下午
package system

import (
	"github.com/shirou/gopsutil/cpu"
	"github.com/shirou/gopsutil/disk"
	"github.com/shirou/gopsutil/load"
)

// CPUDetail CPU详情
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 6:20 下午 2021/10/12
type CPUDetail struct {
	BaseInfo    cpu.InfoStat    `json:"base_info"` // 基础信息
	Time        []cpu.TimesStat `json:"time"`      // cpu时间
	Percent     []float64       `json:"percent"`   // 使用率
	CoreCntInfo CPUCoreCnt      `json:"cnt_info"`  // 核心数信息
	Load        *load.AvgStat   `json:"load"`      // 负载信息
}

// CPUCoreCnt cpu核数信息
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 6:22 下午 2021/10/12
type CPUCoreCnt struct {
	Logical  int `json:"logical"`  // 逻辑核数
	Physical int `json:"physical"` // 物理核数
}

// DiskDetail 磁盘信息
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 8:12 下午 2021/10/12
type DiskDetail struct {
	PartitionStat disk.PartitionStat `json:"partition_stat"`
	DiskStat      *disk.UsageStat    `json:"disk_stat"`
	MemoryUnit    string             `json:"memory_unit"` // 空间的单位  KB / MB / GB
}

// OutputDiskInfo 磁盘信息
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 8:40 下午 2021/10/12
type OutputDiskInfo struct {
	DiskList []*DiskDetail                  `json:"disk_list"`
	IOStat   map[string]disk.IOCountersStat `json:"io_stat"`
}
